package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionDispatchContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionProcessContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.util.MesPcnException;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPartContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionProcessContext;
import cn.estsh.i3plus.mes.pcn.api.iservice.busi.ISyncFuncService;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPart;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCell;
import cn.estsh.i3plus.pojo.mes.model.GenSerialNoModel;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import cn.estsh.i3plus.pojo.mes.repository.MesPartRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesProduceSnRepository;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import cn.hutool.core.date.DateUtil;
import com.google.common.base.Objects;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Description : 完成工步
 * @Author : zxw
 **/
@Slf4j
@Service
public class MesEndStepService extends BaseStepService {


    @Autowired
    private IMesProductionDispatchContextStepService mesProductionDispatchContextStepService;

    /*
     * @param reqBean
     * @return
     */
    @Override
    public StepResult execute(StationRequestBean reqBean) {

        StationResultBean resultBean = new StationResultBean();

        StepResult stepResult = StepResult.getSuccessComplete();

        mesProductionDispatchContextStepService.deleteFirstMouldNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteMouldNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductResultContext(reqBean);
        mesProductionDispatchContextStepService.deleteReadySignalContext(reqBean);

        mesProductionDispatchContextStepService.deleteMesRawPartChargingDataContext(reqBean);
        mesProductionDispatchContextStepService.deletePartDataContext(reqBean);
        mesProductionDispatchContextStepService.deleteProdRuleDataContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionLockContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPartContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPartNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPsInContext(reqBean);
        mesProductionDispatchContextStepService.deleteProductionPsOutContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanAssemblySnContext(reqBean);
        mesProductionDispatchContextStepService.deleteSendProcessCmdContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanWorkOrderNoContext(reqBean);
        mesProductionDispatchContextStepService.deleteScanProductSnContext(reqBean);
        mesProductionDispatchContextStepService.deleteFunctionChooseCavityOrderContext(reqBean);


        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(), stepResult, "完成工步执行成功");

    }
}
